require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_POWERPC_ELF_MACHDEP_H_)) {
    eval 'sub _POWERPC_ELF_MACHDEP_H_ () {1;}' unless defined(&_POWERPC_ELF_MACHDEP_H_);
    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2MSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
    eval 'sub ELF32_MACHDEP_ID_CASES () { &case  &EM_PPC:  &break;;}' unless defined(&ELF32_MACHDEP_ID_CASES);
    eval 'sub ELF64_MACHDEP_ENDIANNESS () { &ELFDATA2MSB;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
    eval 'sub ELF64_MACHDEP_ID_CASES () { &case  &EM_PPC64:  &break;;}' unless defined(&ELF64_MACHDEP_ID_CASES);
    eval 'sub ELF32_MACHDEP_ID () { &EM_PPC;}' unless defined(&ELF32_MACHDEP_ID);
    eval 'sub ELF64_MACHDEP_ID () { &EM_PPC64;}' unless defined(&ELF64_MACHDEP_ID);
    if(defined(&_LP64)) {
	eval 'sub KERN_ELFSIZE () {64;}' unless defined(&KERN_ELFSIZE);
	eval 'sub ARCH_ELFSIZE () {64;}' unless defined(&ARCH_ELFSIZE);
    } else {
	eval 'sub KERN_ELFSIZE () {32;}' unless defined(&KERN_ELFSIZE);
	eval 'sub ARCH_ELFSIZE () {32;}' unless defined(&ARCH_ELFSIZE);
    }
    eval 'sub DT_PPC_GOT () { &DT_LOPROC;}' unless defined(&DT_PPC_GOT);
    eval 'sub DT_PPC64_GLINK () {( &DT_LOPROC + 0);}' unless defined(&DT_PPC64_GLINK);
    eval 'sub DT_PPC64_OPD () {( &DT_LOPROC + 1);}' unless defined(&DT_PPC64_OPD);
    eval 'sub DT_PPC64_OPDSZ () {( &DT_LOPROC + 2);}' unless defined(&DT_PPC64_OPDSZ);
    eval 'sub DT_PPC64_TLSOPT () {( &DT_LOPROC + 3);}' unless defined(&DT_PPC64_TLSOPT);
    eval 'sub R_PPC_NONE () {0;}' unless defined(&R_PPC_NONE);
    eval 'sub R_PPC_ADDR32 () {1;}' unless defined(&R_PPC_ADDR32);
    eval 'sub R_PPC_ADDR24 () {2;}' unless defined(&R_PPC_ADDR24);
    eval 'sub R_PPC_ADDR16 () {3;}' unless defined(&R_PPC_ADDR16);
    eval 'sub R_PPC_ADDR16_LO () {4;}' unless defined(&R_PPC_ADDR16_LO);
    eval 'sub R_PPC_ADDR16_HI () {5;}' unless defined(&R_PPC_ADDR16_HI);
    eval 'sub R_PPC_ADDR16_HA () {6;}' unless defined(&R_PPC_ADDR16_HA);
    eval 'sub R_PPC_ADDR14 () {7;}' unless defined(&R_PPC_ADDR14);
    eval 'sub R_PPC_ADDR14_TAKEN () {8;}' unless defined(&R_PPC_ADDR14_TAKEN);
    eval 'sub R_PPC_ADDR14_NTAKEN () {9;}' unless defined(&R_PPC_ADDR14_NTAKEN);
    eval 'sub R_PPC_REL24 () {10;}' unless defined(&R_PPC_REL24);
    eval 'sub R_PPC_REL14 () {11;}' unless defined(&R_PPC_REL14);
    eval 'sub R_PPC_REL14_TAKEN () {12;}' unless defined(&R_PPC_REL14_TAKEN);
    eval 'sub R_PPC_REL14_NTAKEN () {13;}' unless defined(&R_PPC_REL14_NTAKEN);
    eval 'sub R_PPC_GOT16 () {14;}' unless defined(&R_PPC_GOT16);
    eval 'sub R_PPC_GOT16_LO () {15;}' unless defined(&R_PPC_GOT16_LO);
    eval 'sub R_PPC_GOT16_HI () {16;}' unless defined(&R_PPC_GOT16_HI);
    eval 'sub R_PPC_GOT16_HA () {17;}' unless defined(&R_PPC_GOT16_HA);
    eval 'sub R_PPC_PLTREL24 () {18;}' unless defined(&R_PPC_PLTREL24);
    eval 'sub R_PPC_COPY () {19;}' unless defined(&R_PPC_COPY);
    eval 'sub R_PPC_GLOB_DAT () {20;}' unless defined(&R_PPC_GLOB_DAT);
    eval 'sub R_PPC_JMP_SLOT () {21;}' unless defined(&R_PPC_JMP_SLOT);
    eval 'sub R_PPC_RELATIVE () {22;}' unless defined(&R_PPC_RELATIVE);
    eval 'sub R_PPC_LOCAL24PC () {23;}' unless defined(&R_PPC_LOCAL24PC);
    eval 'sub R_PPC_UADDR32 () {24;}' unless defined(&R_PPC_UADDR32);
    eval 'sub R_PPC_UADDR16 () {25;}' unless defined(&R_PPC_UADDR16);
    eval 'sub R_PPC_REL32 () {26;}' unless defined(&R_PPC_REL32);
    eval 'sub R_PPC_PLT32 () {27;}' unless defined(&R_PPC_PLT32);
    eval 'sub R_PPC_PLTREL () {28;}' unless defined(&R_PPC_PLTREL);
    eval 'sub R_PPC_PLT16_LO () {29;}' unless defined(&R_PPC_PLT16_LO);
    eval 'sub R_PPC_PLT16_HI () {30;}' unless defined(&R_PPC_PLT16_HI);
    eval 'sub R_PPC_PLT16_HA () {31;}' unless defined(&R_PPC_PLT16_HA);
    eval 'sub R_PPC_SDAREL16 () {32;}' unless defined(&R_PPC_SDAREL16);
    eval 'sub R_PPC_SECTOFF () {33;}' unless defined(&R_PPC_SECTOFF);
    eval 'sub R_PPC_SECTOFF_LO () {34;}' unless defined(&R_PPC_SECTOFF_LO);
    eval 'sub R_PPC_SECTOFF_HI () {35;}' unless defined(&R_PPC_SECTOFF_HI);
    eval 'sub R_PPC_SECTOFF_HA () {36;}' unless defined(&R_PPC_SECTOFF_HA);
    eval 'sub R_PPC_ADDR30 () {37;}' unless defined(&R_PPC_ADDR30);
    eval 'sub R_PPC_ADDR64 () {38;}' unless defined(&R_PPC_ADDR64);
    eval 'sub R_PPC_ADDR16_HIGHER () {39;}' unless defined(&R_PPC_ADDR16_HIGHER);
    eval 'sub R_PPC_ADDR16_HIGHERA () {40;}' unless defined(&R_PPC_ADDR16_HIGHERA);
    eval 'sub R_PPC_ADDR16_HIGHEST () {41;}' unless defined(&R_PPC_ADDR16_HIGHEST);
    eval 'sub R_PPC_ADDR16_HIGHESTA () {42;}' unless defined(&R_PPC_ADDR16_HIGHESTA);
    eval 'sub R_PPC_UADDR64 () {43;}' unless defined(&R_PPC_UADDR64);
    eval 'sub R_PPC_REL64 () {44;}' unless defined(&R_PPC_REL64);
    eval 'sub R_PPC_PLT64 () {45;}' unless defined(&R_PPC_PLT64);
    eval 'sub R_PPC_PLTREL4 () {46;}' unless defined(&R_PPC_PLTREL4);
    eval 'sub R_PPC_TOC16 () {47;}' unless defined(&R_PPC_TOC16);
    eval 'sub R_PPC_TOC16_LO () {48;}' unless defined(&R_PPC_TOC16_LO);
    eval 'sub R_PPC_TOC16_HI () {49;}' unless defined(&R_PPC_TOC16_HI);
    eval 'sub R_PPC_TOC16_HA () {50;}' unless defined(&R_PPC_TOC16_HA);
    eval 'sub R_PPC_TOC () {51;}' unless defined(&R_PPC_TOC);
    eval 'sub R_PPC_PLTGOT16 () {52;}' unless defined(&R_PPC_PLTGOT16);
    eval 'sub R_PPC_PLTGOT16_LO () {53;}' unless defined(&R_PPC_PLTGOT16_LO);
    eval 'sub R_PPC_PLTGOT16_HI () {54;}' unless defined(&R_PPC_PLTGOT16_HI);
    eval 'sub R_PPC_PLTGOT16_HA () {55;}' unless defined(&R_PPC_PLTGOT16_HA);
    eval 'sub R_PPC_ADDR16_DS () {56;}' unless defined(&R_PPC_ADDR16_DS);
    eval 'sub R_PPC_ADDR16_LO_DS () {57;}' unless defined(&R_PPC_ADDR16_LO_DS);
    eval 'sub R_PPC_GOT16_DS () {58;}' unless defined(&R_PPC_GOT16_DS);
    eval 'sub R_PPC_GOT16_LO_DS () {59;}' unless defined(&R_PPC_GOT16_LO_DS);
    eval 'sub R_PPC_PLT16_LO_DS () {60;}' unless defined(&R_PPC_PLT16_LO_DS);
    eval 'sub R_PPC_SECTOFF16_DS () {61;}' unless defined(&R_PPC_SECTOFF16_DS);
    eval 'sub R_PPC_SECTOFF16_LO_DS () {62;}' unless defined(&R_PPC_SECTOFF16_LO_DS);
    eval 'sub R_PPC_TOC16_DS () {63;}' unless defined(&R_PPC_TOC16_DS);
    eval 'sub R_PPC_TOC16_LO_DS () {64;}' unless defined(&R_PPC_TOC16_LO_DS);
    eval 'sub R_PPC_PLTGOT16_DS () {65;}' unless defined(&R_PPC_PLTGOT16_DS);
    eval 'sub R_PPC_PLTGOT16_LO_DS () {66;}' unless defined(&R_PPC_PLTGOT16_LO_DS);
    eval 'sub R_PPC_TLS () {67;}' unless defined(&R_PPC_TLS);
    eval 'sub R_PPC_DTPMOD () {68;}' unless defined(&R_PPC_DTPMOD);
    eval 'sub R_PPC_TPREL16 () {69;}' unless defined(&R_PPC_TPREL16);
    eval 'sub R_PPC_TPREL16_LO () {70;}' unless defined(&R_PPC_TPREL16_LO);
    eval 'sub R_PPC_TPREL16_HI () {71;}' unless defined(&R_PPC_TPREL16_HI);
    eval 'sub R_PPC_TPREL16_HA () {72;}' unless defined(&R_PPC_TPREL16_HA);
    eval 'sub R_PPC_TPREL () {73;}' unless defined(&R_PPC_TPREL);
    eval 'sub R_PPC_DTPREL16 () {74;}' unless defined(&R_PPC_DTPREL16);
    eval 'sub R_PPC_DTPREL16_LO () {75;}' unless defined(&R_PPC_DTPREL16_LO);
    eval 'sub R_PPC_DTPREL16_HI () {76;}' unless defined(&R_PPC_DTPREL16_HI);
    eval 'sub R_PPC_DTPREL16_HA () {77;}' unless defined(&R_PPC_DTPREL16_HA);
    eval 'sub R_PPC_DTPREL () {78;}' unless defined(&R_PPC_DTPREL);
    eval 'sub R_PPC_GOT_TLSGD16 () {79;}' unless defined(&R_PPC_GOT_TLSGD16);
    eval 'sub R_PPC_GOT_TLSGD16_LO () {80;}' unless defined(&R_PPC_GOT_TLSGD16_LO);
    eval 'sub R_PPC_GOT_TLSGD16_HI () {81;}' unless defined(&R_PPC_GOT_TLSGD16_HI);
    eval 'sub R_PPC_GOT_TLSGD16_HA () {82;}' unless defined(&R_PPC_GOT_TLSGD16_HA);
    eval 'sub R_PPC_GOT_TLSLD16 () {83;}' unless defined(&R_PPC_GOT_TLSLD16);
    eval 'sub R_PPC_GOT_TLSLD16_LO () {84;}' unless defined(&R_PPC_GOT_TLSLD16_LO);
    eval 'sub R_PPC_GOT_TLSLD16_HI () {85;}' unless defined(&R_PPC_GOT_TLSLD16_HI);
    eval 'sub R_PPC_GOT_TLSLD16_HA () {86;}' unless defined(&R_PPC_GOT_TLSLD16_HA);
    eval 'sub R_PPC_GOT_TPREL16 () {87;}' unless defined(&R_PPC_GOT_TPREL16);
    eval 'sub R_PPC_GOT_TPREL16_LO () {88;}' unless defined(&R_PPC_GOT_TPREL16_LO);
    eval 'sub R_PPC_GOT_TPREL16_HI () {89;}' unless defined(&R_PPC_GOT_TPREL16_HI);
    eval 'sub R_PPC_GOT_TPREL16_HA () {90;}' unless defined(&R_PPC_GOT_TPREL16_HA);
    eval 'sub R_PPC_GOT_DTPREL16 () {91;}' unless defined(&R_PPC_GOT_DTPREL16);
    eval 'sub R_PPC_GOT_DTPREL16_LO () {92;}' unless defined(&R_PPC_GOT_DTPREL16_LO);
    eval 'sub R_PPC_GOT_DTPREL16_HI () {93;}' unless defined(&R_PPC_GOT_DTPREL16_HI);
    eval 'sub R_PPC_GOT_DTPREL16_HA () {94;}' unless defined(&R_PPC_GOT_DTPREL16_HA);
    eval 'sub R_PPC_TLSGD () {95;}' unless defined(&R_PPC_TLSGD);
    eval 'sub R_PPC_TLSLD () {96;}' unless defined(&R_PPC_TLSLD);
    eval 'sub R_PPC_TPREL16_DS () {95;}' unless defined(&R_PPC_TPREL16_DS);
    eval 'sub R_PPC_TPREL16_LO_DS () {96;}' unless defined(&R_PPC_TPREL16_LO_DS);
    eval 'sub R_PPC_TPREL16_HIGHER () {97;}' unless defined(&R_PPC_TPREL16_HIGHER);
    eval 'sub R_PPC_TPREL16_HIGHERA () {98;}' unless defined(&R_PPC_TPREL16_HIGHERA);
    eval 'sub R_PPC_TPREL16_HIGHEST () {99;}' unless defined(&R_PPC_TPREL16_HIGHEST);
    eval 'sub R_PPC_TPREL16_HIGHESTA () {100;}' unless defined(&R_PPC_TPREL16_HIGHESTA);
    eval 'sub R_PPC_DTPREL16_DS () {101;}' unless defined(&R_PPC_DTPREL16_DS);
    eval 'sub R_PPC_DTPREL16_LO_DS () {102;}' unless defined(&R_PPC_DTPREL16_LO_DS);
    eval 'sub R_PPC_DTPREL16_HIGHER () {103;}' unless defined(&R_PPC_DTPREL16_HIGHER);
    eval 'sub R_PPC_DTPREL16_HIGHERA () {104;}' unless defined(&R_PPC_DTPREL16_HIGHERA);
    eval 'sub R_PPC_DTPREL16_HIGHEST () {105;}' unless defined(&R_PPC_DTPREL16_HIGHEST);
    eval 'sub R_PPC_DTPREL16_HIGHESTA () {106;}' unless defined(&R_PPC_DTPREL16_HIGHESTA);
    eval 'sub R_PPC_IRELATIVE () {248;}' unless defined(&R_PPC_IRELATIVE);
    eval 'sub R_PPC_REL16 () {249;}' unless defined(&R_PPC_REL16);
    eval 'sub R_PPC_REL16_LO () {250;}' unless defined(&R_PPC_REL16_LO);
    eval 'sub R_PPC_REL16_HI () {251;}' unless defined(&R_PPC_REL16_HI);
    eval 'sub R_PPC_REL16_HA () {252;}' unless defined(&R_PPC_REL16_HA);
    eval 'sub R_TYPE {
        my($name) = @_;
	    eval q( &__CONCAT( &R_PPC_,$name));
    }' unless defined(&R_TYPE);
}
1;
