require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_POWERPC_PSL_H_)) {
    eval 'sub _POWERPC_PSL_H_ () {1;}' unless defined(&_POWERPC_PSL_H_);
    eval 'sub PSL_VEC () {0x2000000;}' unless defined(&PSL_VEC);
    eval 'sub PSL_SPV () {0x2000000;}' unless defined(&PSL_SPV);
    eval 'sub PSL_UCLE () {0x400000;}' unless defined(&PSL_UCLE);
    eval 'sub PSL_POW () {0x40000;}' unless defined(&PSL_POW);
    eval 'sub PSL_WE () { &PSL_POW;}' unless defined(&PSL_WE);
    eval 'sub PSL_TGPR () {0x20000;}' unless defined(&PSL_TGPR);
    eval 'sub PSL_CE () { &PSL_TGPR;}' unless defined(&PSL_CE);
    eval 'sub PSL_ILE () {0x10000;}' unless defined(&PSL_ILE);
    eval 'sub PSL_EE () {0x8000;}' unless defined(&PSL_EE);
    eval 'sub PSL_PR () {0x4000;}' unless defined(&PSL_PR);
    eval 'sub PSL_FP () {0x2000;}' unless defined(&PSL_FP);
    eval 'sub PSL_ME () {0x1000;}' unless defined(&PSL_ME);
    eval 'sub PSL_FE0 () {0x800;}' unless defined(&PSL_FE0);
    eval 'sub PSL_SE () {0x400;}' unless defined(&PSL_SE);
    eval 'sub PSL_DWE () { &PSL_SE;}' unless defined(&PSL_DWE);
    eval 'sub PSL_UBLE () { &PSL_SE;}' unless defined(&PSL_UBLE);
    eval 'sub PSL_BE () {0x200;}' unless defined(&PSL_BE);
    eval 'sub PSL_DE () { &PSL_BE;}' unless defined(&PSL_DE);
    eval 'sub PSL_FE1 () {0x100;}' unless defined(&PSL_FE1);
    eval 'sub PSL_IP () {0x40;}' unless defined(&PSL_IP);
    eval 'sub PSL_IR () {0x20;}' unless defined(&PSL_IR);
    eval 'sub PSL_IS () { &PSL_IR;}' unless defined(&PSL_IS);
    eval 'sub PSL_DR () {0x10;}' unless defined(&PSL_DR);
    eval 'sub PSL_DS () { &PSL_DR;}' unless defined(&PSL_DS);
    eval 'sub PSL_PM () {0x8;}' unless defined(&PSL_PM);
    eval 'sub PSL_PMM () { &PSL_PM;}' unless defined(&PSL_PMM);
    eval 'sub PSL_RI () {0x2;}' unless defined(&PSL_RI);
    eval 'sub PSL_LE () {0x1;}' unless defined(&PSL_LE);
    eval 'sub PSL_601_MASK () {~( &PSL_VEC| &PSL_POW| &PSL_ILE| &PSL_BE| &PSL_RI| &PSL_LE);}' unless defined(&PSL_601_MASK);
    eval 'sub PSL_970_MASK () {~( &PSL_ILE| &PSL_LE);}' unless defined(&PSL_970_MASK);
    eval 'sub PSL_FE_DIS () {0;}' unless defined(&PSL_FE_DIS);
    eval 'sub PSL_FE_NONREC () { &PSL_FE1;}' unless defined(&PSL_FE_NONREC);
    eval 'sub PSL_FE_REC () { &PSL_FE0;}' unless defined(&PSL_FE_REC);
    eval 'sub PSL_FE_PREC () {( &PSL_FE0 |  &PSL_FE1);}' unless defined(&PSL_FE_PREC);
    eval 'sub PSL_FE_DFLT () { &PSL_FE_DIS;}' unless defined(&PSL_FE_DFLT);
    eval 'sub PSL_MBO () {0;}' unless defined(&PSL_MBO);
    eval 'sub PSL_MBZ () {0;}' unless defined(&PSL_MBZ);
    if(defined(&_KERNEL)  && !defined(&_LOCORE)) {
	if(defined(&_KERNEL_OPT)) {
	    require './powerpc/opt_ppcarch.ph';
	}
	if(defined(&PPC_OEA) || defined (&PPC_OEA64_BRIDGE) || defined (&PPC_OEA64) || defined(&_MODULE)) {
	    eval 'sub PSL_USERSET () { &cpu_psluserset;}' unless defined(&PSL_USERSET);
	    eval 'sub PSL_USERMOD () { &cpu_pslusermod;}' unless defined(&PSL_USERMOD);
	    eval 'sub PSL_USERMASK () { &cpu_pslusermask;}' unless defined(&PSL_USERMASK);
	}
 elsif(defined(&PPC_BOOKE)) {
	    eval 'sub PSL_USERSET () {( &PSL_EE |  &PSL_PR |  &PSL_IS |  &PSL_DS |  &PSL_ME |  &PSL_CE);}' unless defined(&PSL_USERSET);
	    eval 'sub PSL_USERMASK () {( &PSL_SPV |  &PSL_CE | 0xffff);}' unless defined(&PSL_USERMASK);
	    eval 'sub PSL_USERMOD () {(0);}' unless defined(&PSL_USERMOD);
	} else {
	    if(defined(&PPC_IBM403)) {
		eval 'sub PSL_USERSET () {( &PSL_EE |  &PSL_PR |  &PSL_IR |  &PSL_DR |  &PSL_ME);}' unless defined(&PSL_USERSET);
	    } else {
		eval 'sub PSL_USERSET () {( &PSL_EE |  &PSL_PR |  &PSL_IR |  &PSL_DR);}' unless defined(&PSL_USERSET);
	    }
	    eval 'sub PSL_USERMASK () {0xffff;}' unless defined(&PSL_USERMASK);
	    eval 'sub PSL_USERMOD () {(0);}' unless defined(&PSL_USERMOD);
	}
	eval 'sub PSL_USERSRR1 () {(( &PSL_USERSET| &PSL_USERMOD) &  &PSL_USERMASK);}' unless defined(&PSL_USERSRR1);
	eval 'sub PSL_USEROK_P {
	    my($psl) = @_;
    	    eval q(((($psl) & ~ &PSL_USERMOD) ==  &PSL_USERSET));
	}' unless defined(&PSL_USEROK_P);
    }
}
1;
